import{s as an,n as rn,o as sn}from"../chunks/scheduler.6062bdaf.js";import{S as mn,i as un,g as a,s as o,r as u,A as dn,h as r,f as n,c as i,j as h,u as d,x as f,k as x,y as t,a as m,v as l,d as c,t as p,w as g}from"../chunks/index.4bca734e.js";import{D as z}from"../chunks/Docstring.ed07512f.js";import{H as Qe}from"../chunks/Heading.723dceba.js";function ln(Pt){let q,Ae,Ne,Le,W,Fe,V,It="The configuration classes are the way to specify how a task should be done. There are two tasks supported with the ONNX Runtime package:",De,R,Mt='<li><p>Optimization: Performed by the <a href="/docs/optimum/main/en/onnxruntime/package_reference/optimization#optimum.onnxruntime.ORTOptimizer">ORTOptimizer</a>, this task can be tweaked using an <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.OptimizationConfig">OptimizationConfig</a>.</p></li> <li><p>Quantization: Performed by the <a href="/docs/optimum/main/en/onnxruntime/package_reference/quantization#optimum.onnxruntime.ORTQuantizer">ORTQuantizer</a>, quantization can be set using a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a>. A calibration step is required in some cases (post training static quantization), which can be specified using a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.CalibrationConfig">CalibrationConfig</a>.</p></li>',Pe,E,Ie,w,H,st,ue,Wt=`OptimizationConfig is the configuration class handling all the ONNX Runtime optimization parameters.
There are two stacks of optimizations:`,mt,de,Vt="<li>The ONNX Runtime general-purpose optimization tool: it can work on any ONNX model.</li> <li>The ONNX Runtime transformers optimization tool: it can only work on a subset of transformers models.</li>",Me,_,X,ut,le,Rt="Factory to create common <code>OptimizationConfig</code>.",dt,N,U,lt,ce,Et="Creates an O1 <code>~OptimizationConfig</code>.",ct,k,S,pt,pe,Ht="Creates an O2 <code>~OptimizationConfig</code>.",gt,A,G,ft,ge,Xt="Creates an O3 <code>~OptimizationConfig</code>.",_t,L,B,ht,fe,Ut="Creates an O4 <code>~OptimizationConfig</code>.",xt,F,j,bt,_e,St="Creates an <code>~OptimizationConfig</code> with pre-defined arguments according to an optimization level.",We,K,Ve,$,J,zt,he,Gt="QuantizationConfig is the configuration class handling all the ONNX Runtime quantization parameters.",Re,Y,Ee,b,Z,vt,D,ee,yt,xe,Bt='Creates a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a> fit for ARM64.',Ct,P,te,wt,be,jt='Creates a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a> fit for CPU with AVX2 instruction set.',Ot,I,ne,qt,ze,Kt='Creates a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a> fit for CPU with AVX512 instruction set.',$t,v,oe,Tt,ve,Jt='Creates a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a> fit for CPU with AVX512-VNNI instruction set.',Qt,ye,Yt=`When targeting Intel AVX512-VNNI CPU underlying execution engine leverage the CPU instruction VPDPBUSD to
compute  \\i32 += i8(w) * u8(x)\\ within a single instruction.`,Nt,Ce,Zt=`AVX512-VNNI (AVX512 Vector Neural Network Instruction)
is an x86 extension Instruction set and is a part of the AVX-512 ISA.`,kt,we,en="AVX512 VNNI is designed to accelerate convolutional neural network for INT8 inference.",At,M,ie,Lt,Oe,tn='Creates a <a href="/docs/optimum/main/en/onnxruntime/package_reference/configuration#optimum.onnxruntime.QuantizationConfig">QuantizationConfig</a> fit for TensorRT static quantization, targetting NVIDIA GPUs.',He,ae,Xe,T,re,Ft,qe,nn=`CalibrationConfig is the configuration class handling all the ONNX Runtime parameters related to the calibration
step of static quantization.`,Ue,se,Se,Q,me,Dt,$e,on=`ORTConfig is the configuration class handling all the ONNX Runtime parameters related to the ONNX IR model export,
optimization and quantization parameters.`,Ge,ke,Be;return W=new Qe({props:{title:"Configuration",local:"configuration",headingTag:"h1"}}),E=new Qe({props:{title:"OptimizationConfig",local:"optimum.onnxruntime.OptimizationConfig",headingTag:"h2"}}),H=new z({props:{name:"class optimum.onnxruntime.OptimizationConfig",anchor:"optimum.onnxruntime.OptimizationConfig",parameters:[{name:"optimization_level",val:": int = 1"},{name:"optimize_for_gpu",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"optimize_with_onnxruntime_only",val:": typing.Optional[bool] = None"},{name:"enable_transformers_specific_optimizations",val:": bool = True"},{name:"disable_gelu",val:": typing.Optional[bool] = None"},{name:"disable_gelu_fusion",val:": bool = False"},{name:"disable_layer_norm",val:": typing.Optional[bool] = None"},{name:"disable_layer_norm_fusion",val:": bool = False"},{name:"disable_attention",val:": typing.Optional[bool] = None"},{name:"disable_attention_fusion",val:": bool = False"},{name:"disable_skip_layer_norm",val:": typing.Optional[bool] = None"},{name:"disable_skip_layer_norm_fusion",val:": bool = False"},{name:"disable_bias_skip_layer_norm",val:": typing.Optional[bool] = None"},{name:"disable_bias_skip_layer_norm_fusion",val:": bool = False"},{name:"disable_bias_gelu",val:": typing.Optional[bool] = None"},{name:"disable_bias_gelu_fusion",val:": bool = False"},{name:"disable_embed_layer_norm",val:": bool = True"},{name:"disable_embed_layer_norm_fusion",val:": bool = True"},{name:"enable_gelu_approximation",val:": bool = False"},{name:"use_mask_index",val:": bool = False"},{name:"no_attention_mask",val:": bool = False"},{name:"disable_shape_inference",val:": bool = False"},{name:"use_multi_head_attention",val:": bool = False"},{name:"enable_gemm_fast_gelu_fusion",val:": bool = False"},{name:"use_raw_attention_mask",val:": bool = False"},{name:"disable_group_norm_fusion",val:": bool = True"},{name:"disable_packed_kv",val:": bool = True"}],parametersDescription:[{anchor:"optimum.onnxruntime.OptimizationConfig.optimization_level",description:`<strong>optimization_level</strong> (<code>int</code>, defaults to 1) &#x2014;
Optimization level performed by ONNX Runtime of the loaded graph.
Supported optimization level are 0, 1, 2 and 99.<ul>
<li>0: will disable all optimizations</li>
<li>1: will enable basic optimizations</li>
<li>2: will enable basic and extended optimizations, including complex node fusions applied to the nodes
assigned to the CPU or CUDA execution provider, making the resulting optimized graph hardware dependent</li>
<li>99: will enable all available optimizations including layout optimizations</li>
</ul>`,name:"optimization_level"},{anchor:"optimum.onnxruntime.OptimizationConfig.optimize_for_gpu",description:`<strong>optimize_for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to optimize the model for GPU inference.
The optimized graph might contain operators for GPU or CPU only when <code>optimization_level</code> &gt; 1.`,name:"optimize_for_gpu"},{anchor:"optimum.onnxruntime.OptimizationConfig.fp16",description:`<strong>fp16</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether all weights and nodes should be converted from float32 to float16.`,name:"fp16"},{anchor:"optimum.onnxruntime.OptimizationConfig.enable_transformers_specific_optimizations",description:`<strong>enable_transformers_specific_optimizations</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to only use <code>transformers</code> specific optimizations on top of ONNX Runtime general optimizations.`,name:"enable_transformers_specific_optimizations"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_gelu_fusion",description:`<strong>disable_gelu_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable the Gelu fusion.`,name:"disable_gelu_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_layer_norm_fusion",description:`<strong>disable_layer_norm_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable Layer Normalization fusion.`,name:"disable_layer_norm_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_attention_fusion",description:`<strong>disable_attention_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable Attention fusion.`,name:"disable_attention_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_skip_layer_norm_fusion",description:`<strong>disable_skip_layer_norm_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable SkipLayerNormalization fusion.`,name:"disable_skip_layer_norm_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_bias_skip_layer_norm_fusion",description:`<strong>disable_bias_skip_layer_norm_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable Add Bias and SkipLayerNormalization fusion.`,name:"disable_bias_skip_layer_norm_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_bias_gelu_fusion",description:`<strong>disable_bias_gelu_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable Add Bias and Gelu / FastGelu fusion.`,name:"disable_bias_gelu_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_embed_layer_norm_fusion",description:`<strong>disable_embed_layer_norm_fusion</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to disable EmbedLayerNormalization fusion.
The default value is set to <code>True</code> since this fusion is incompatible with ONNX Runtime quantization.`,name:"disable_embed_layer_norm_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.enable_gelu_approximation",description:`<strong>enable_gelu_approximation</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to enable Gelu / BiasGelu to FastGelu conversion.
The default value is set to <code>False</code> since this approximation might slightly impact the model&#x2019;s accuracy.`,name:"enable_gelu_approximation"},{anchor:"optimum.onnxruntime.OptimizationConfig.use_mask_index",description:`<strong>use_mask_index</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use mask index instead of raw attention mask in the attention operator.`,name:"use_mask_index"},{anchor:"optimum.onnxruntime.OptimizationConfig.no_attention_mask",description:`<strong>no_attention_mask</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to not use attention masks. Only works for bert model type.`,name:"no_attention_mask"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_embed_layer_norm",description:`<strong>disable_embed_layer_norm</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to disable EmbedLayerNormalization fusion.
The default value is set to <code>True</code> since this fusion is incompatible with ONNX Runtime quantization`,name:"disable_embed_layer_norm"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_shape_inference",description:`<strong>disable_shape_inference</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to disable symbolic shape inference.
The default value is set to <code>False</code> but symbolic shape inference might cause issues sometimes.`,name:"disable_shape_inference"},{anchor:"optimum.onnxruntime.OptimizationConfig.use_multi_head_attention",description:`<strong>use_multi_head_attention</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Experimental argument. Use MultiHeadAttention instead of Attention operator, which has merged weights for Q/K/V projection,
which might be faster in some cases since 3 MatMul is merged into one.&#x201D;
&#x201C;Note that MultiHeadAttention might be slower than Attention when qkv are not packed. &#x201D;`,name:"use_multi_head_attention"},{anchor:"optimum.onnxruntime.OptimizationConfig.enable_gemm_fast_gelu_fusion",description:`<strong>enable_gemm_fast_gelu_fusion</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Enable GemmfastGelu fusion.`,name:"enable_gemm_fast_gelu_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.use_raw_attention_mask",description:`<strong>use_raw_attention_mask</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Use raw attention mask. Use this option if your input is not right-side padding. This might deactivate fused attention and get worse performance.`,name:"use_raw_attention_mask"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_group_norm_fusion",description:`<strong>disable_group_norm_fusion</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Do not fuse GroupNorm. Only works for model_type=unet.`,name:"disable_group_norm_fusion"},{anchor:"optimum.onnxruntime.OptimizationConfig.disable_packed_kv",description:`<strong>disable_packed_kv</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Do not use packed kv in cross attention. Only works for model_type=unet.`,name:"disable_packed_kv"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L648"}}),X=new z({props:{name:"class optimum.onnxruntime.AutoOptimizationConfig",anchor:"optimum.onnxruntime.AutoOptimizationConfig",parameters:[],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L816"}}),U=new z({props:{name:"O1",anchor:"optimum.onnxruntime.AutoOptimizationConfig.O1",parameters:[{name:"for_gpu",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O1.for_gpu",description:`<strong>for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the model to optimize will run on GPU, some optimizations depends on the hardware the model
will run on. Only needed for optimization_level &gt; 1.`,name:"for_gpu"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O1.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Arguments to provide to the <code>~OptimizationConfig</code> constructor.`,name:"kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L876",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The <code>OptimizationConfig</code> corresponding to the O1 optimization level.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>OptimizationConfig</code></p>
`}}),S=new z({props:{name:"O2",anchor:"optimum.onnxruntime.AutoOptimizationConfig.O2",parameters:[{name:"for_gpu",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O2.for_gpu",description:`<strong>for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the model to optimize will run on GPU, some optimizations depends on the hardware the model
will run on. Only needed for optimization_level &gt; 1.`,name:"for_gpu"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O2.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Arguments to provide to the <code>~OptimizationConfig</code> constructor.`,name:"kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L893",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The <code>OptimizationConfig</code> corresponding to the O2 optimization level.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>OptimizationConfig</code></p>
`}}),G=new z({props:{name:"O3",anchor:"optimum.onnxruntime.AutoOptimizationConfig.O3",parameters:[{name:"for_gpu",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O3.for_gpu",description:`<strong>for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the model to optimize will run on GPU, some optimizations depends on the hardware the model
will run on. Only needed for optimization_level &gt; 1.`,name:"for_gpu"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O3.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Arguments to provide to the <code>~OptimizationConfig</code> constructor.`,name:"kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L910",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The <code>OptimizationConfig</code> corresponding to the O3 optimization level.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>OptimizationConfig</code></p>
`}}),B=new z({props:{name:"O4",anchor:"optimum.onnxruntime.AutoOptimizationConfig.O4",parameters:[{name:"for_gpu",val:": bool = True"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O4.for_gpu",description:`<strong>for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the model to optimize will run on GPU, some optimizations depends on the hardware the model
will run on. Only needed for optimization_level &gt; 1.`,name:"for_gpu"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.O4.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Arguments to provide to the <code>~OptimizationConfig</code> constructor.`,name:"kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L927",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The <code>OptimizationConfig</code> corresponding to the O4 optimization level.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>OptimizationConfig</code></p>
`}}),j=new z({props:{name:"with_optimization_level",anchor:"optimum.onnxruntime.AutoOptimizationConfig.with_optimization_level",parameters:[{name:"optimization_level",val:": str"},{name:"for_gpu",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoOptimizationConfig.with_optimization_level.optimization_level",description:`<strong>optimization_level</strong> (<code>str</code>) &#x2014;
The optimization level, the following values are allowed:<ul>
<li>O1: Basic general optimizations</li>
<li>O2: Basic and extended general optimizations, transformers-specific fusions.</li>
<li>O3: Same as O2 with Fast Gelu approximation.</li>
<li>O4: Same as O3 with mixed precision.</li>
</ul>`,name:"optimization_level"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.with_optimization_level.for_gpu",description:`<strong>for_gpu</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether the model to optimize will run on GPU, some optimizations depends on the hardware the model
will run on. Only needed for optimization_level &gt; 1.`,name:"for_gpu"},{anchor:"optimum.onnxruntime.AutoOptimizationConfig.with_optimization_level.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Arguments to provide to the <code>~OptimizationConfig</code> constructor.`,name:"kwargs"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L843",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The <code>OptimizationConfig</code> corresponding to the requested optimization level.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>OptimizationConfig</code></p>
`}}),K=new Qe({props:{title:"QuantizationConfig",local:"optimum.onnxruntime.QuantizationConfig",headingTag:"h2"}}),J=new z({props:{name:"class optimum.onnxruntime.QuantizationConfig",anchor:"optimum.onnxruntime.QuantizationConfig",parameters:[{name:"is_static",val:": bool"},{name:"format",val:": QuantFormat"},{name:"mode",val:": QuantizationMode = <QuantizationMode.QLinearOps: 1>"},{name:"activations_dtype",val:": QuantType = <QuantType.QUInt8: 1>"},{name:"activations_symmetric",val:": bool = False"},{name:"weights_dtype",val:": QuantType = <QuantType.QInt8: 0>"},{name:"weights_symmetric",val:": bool = True"},{name:"per_channel",val:": bool = False"},{name:"reduce_range",val:": bool = False"},{name:"nodes_to_quantize",val:": typing.List[str] = <factory>"},{name:"nodes_to_exclude",val:": typing.List[str] = <factory>"},{name:"operators_to_quantize",val:": typing.List[str] = <factory>"},{name:"qdq_add_pair_to_weight",val:": bool = False"},{name:"qdq_dedicated_pair",val:": bool = False"},{name:"qdq_op_type_per_channel_support_to_axis",val:": typing.Dict[str, int] = <factory>"}],parametersDescription:[{anchor:"optimum.onnxruntime.QuantizationConfig.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Whether to apply static quantization or dynamic quantization.`,name:"is_static"},{anchor:"optimum.onnxruntime.QuantizationConfig.format",description:`<strong>format</strong> (<code>QuantFormat</code>) &#x2014;
Targeted ONNX Runtime quantization representation format.
For the Operator Oriented (QOperator) format, all the quantized operators have their own ONNX definitions.
For the Tensor Oriented (QDQ) format, the model is quantized by inserting QuantizeLinear / DeQuantizeLinear
operators.`,name:"format"},{anchor:"optimum.onnxruntime.QuantizationConfig.mode",description:`<strong>mode</strong> (<code>QuantizationMode</code>, defaults to <code>QuantizationMode.QLinearOps</code>) &#x2014;
Targeted ONNX Runtime quantization mode, default is QLinearOps to match QDQ format.
When targeting dynamic quantization mode, the default value is <code>QuantizationMode.IntegerOps</code> whereas the
default value for static quantization mode is <code>QuantizationMode.QLinearOps</code>.`,name:"mode"},{anchor:"optimum.onnxruntime.QuantizationConfig.activations_dtype",description:`<strong>activations_dtype</strong> (<code>QuantType</code>, defaults to <code>QuantType.QUInt8</code>) &#x2014;
The quantization data types to use for the activations.`,name:"activations_dtype"},{anchor:"optimum.onnxruntime.QuantizationConfig.activations_symmetric",description:`<strong>activations_symmetric</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to apply symmetric quantization on the activations.`,name:"activations_symmetric"},{anchor:"optimum.onnxruntime.QuantizationConfig.weights_dtype",description:`<strong>weights_dtype</strong> (<code>QuantType</code>, defaults to <code>QuantType.QInt8</code>) &#x2014;
The quantization data types to use for the weights.`,name:"weights_dtype"},{anchor:"optimum.onnxruntime.QuantizationConfig.weights_symmetric",description:`<strong>weights_symmetric</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to apply symmetric quantization on the weights.`,name:"weights_symmetric"},{anchor:"optimum.onnxruntime.QuantizationConfig.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can increase overall
accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.QuantizationConfig.reduce_range",description:`<strong>reduce_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use reduce-range 7-bits integers instead of 8-bits integers.`,name:"reduce_range"},{anchor:"optimum.onnxruntime.QuantizationConfig.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>List[str]</code>, defaults to <code>[]</code>) &#x2014;
List of the nodes names to quantize.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.QuantizationConfig.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>List[str]</code>, defaults to <code>[]</code>) &#x2014;
List of the nodes names to exclude when applying quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.QuantizationConfig.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>List[str]</code>) &#x2014;
List of the operators types to quantize. Defaults to all quantizable operators for the given quantization mode and format.`,name:"operators_to_quantize"},{anchor:"optimum.onnxruntime.QuantizationConfig.qdq_add_pair_to_weight",description:`<strong>qdq_add_pair_to_weight</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
By default, floating-point weights are quantized and feed to solely inserted DeQuantizeLinear node.
If set to True, the floating-point weights will remain and both QuantizeLinear / DeQuantizeLinear nodes
will be inserted.`,name:"qdq_add_pair_to_weight"},{anchor:"optimum.onnxruntime.QuantizationConfig.qdq_dedicated_pair",description:`<strong>qdq_dedicated_pair</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
When inserting QDQ pair, multiple nodes can share a single QDQ pair as their inputs. If True, it will
create an identical and dedicated QDQ pair for each node.`,name:"qdq_dedicated_pair"},{anchor:"optimum.onnxruntime.QuantizationConfig.qdq_op_type_per_channel_support_to_axis",description:`<strong>qdq_op_type_per_channel_support_to_axis</strong> (<code>Dict[str, int]</code>) &#x2014;
Set the channel axis for a specific operator type. Effective only when per channel quantization is
supported and <code>per_channel</code> is set to True.`,name:"qdq_op_type_per_channel_support_to_axis"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L225"}}),Y=new Qe({props:{title:"AutoQuantizationConfig",local:"optimum.onnxruntime.AutoQuantizationConfig",headingTag:"h2"}}),Z=new z({props:{name:"class optimum.onnxruntime.AutoQuantizationConfig",anchor:"optimum.onnxruntime.AutoQuantizationConfig",parameters:[],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L380"}}),ee=new z({props:{name:"arm64",anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64",parameters:[{name:"is_static",val:": bool"},{name:"use_symmetric_activations",val:": bool = False"},{name:"use_symmetric_weights",val:": bool = True"},{name:"per_channel",val:": bool = True"},{name:"nodes_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"nodes_to_exclude",val:": typing.Optional[typing.List[str]] = None"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Boolean flag to indicate whether we target static or dynamic quantization.`,name:"is_static"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.use_symmetric_activations",description:`<strong>use_symmetric_activations</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use symmetric quantization for activations.`,name:"use_symmetric_activations"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.use_symmetric_weights",description:`<strong>use_symmetric_weights</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use symmetric quantization for weights.`,name:"use_symmetric_weights"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can
increase overall accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to quantize. If <code>None</code>, all nodes being operators from <code>operators_to_quantize</code> will be quantized.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to exclude from quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.arm64.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Type of nodes to perform quantization on. By default, all the quantizable operators will be quantized.`,name:"operators_to_quantize"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L381"}}),te=new z({props:{name:"avx2",anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2",parameters:[{name:"is_static",val:": bool"},{name:"use_symmetric_activations",val:": bool = False"},{name:"use_symmetric_weights",val:": bool = True"},{name:"per_channel",val:": bool = True"},{name:"reduce_range",val:": bool = False"},{name:"nodes_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"nodes_to_exclude",val:": typing.Optional[typing.List[str]] = None"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Boolean flag to indicate whether we target static or dynamic quantization.`,name:"is_static"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.use_symmetric_activations",description:`<strong>use_symmetric_activations</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use symmetric quantization for activations.`,name:"use_symmetric_activations"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.use_symmetric_weights",description:`<strong>use_symmetric_weights</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use symmetric quantization for weights.`,name:"use_symmetric_weights"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can
increase overall accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.reduce_range",description:`<strong>reduce_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Indicate whether to use 8-bits integers (False) or reduce-range 7-bits integers (True).
As a baseline, it is always recommended testing with full range (reduce_range = False) and then, if
accuracy drop is significant, to try with reduced range (reduce_range = True).
Intel&#x2019;s CPUs using AVX512 (non VNNI) can suffer from saturation issue when invoking
the VPMADDUBSW instruction. To counter this, one should use 7-bits rather than 8-bits integers.`,name:"reduce_range"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to quantize. If <code>None</code>, all nodes being operators from <code>operators_to_quantize</code> will be quantized.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to exclude from quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx2.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Type of nodes to perform quantization on. By default, all the quantizable operators will be quantized.`,name:"operators_to_quantize"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L432"}}),ne=new z({props:{name:"avx512",anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512",parameters:[{name:"is_static",val:": bool"},{name:"use_symmetric_activations",val:": bool = False"},{name:"use_symmetric_weights",val:": bool = True"},{name:"per_channel",val:": bool = True"},{name:"reduce_range",val:": bool = False"},{name:"nodes_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"nodes_to_exclude",val:": typing.Optional[typing.List[str]] = None"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Boolean flag to indicate whether we target static or dynamic quantization.`,name:"is_static"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.use_symmetric_activations",description:`<strong>use_symmetric_activations</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use symmetric quantization for activations.`,name:"use_symmetric_activations"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.use_symmetric_weights",description:`<strong>use_symmetric_weights</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use symmetric quantization for weights.`,name:"use_symmetric_weights"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can
increase overall accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.reduce_range",description:`<strong>reduce_range</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Indicate whether to use 8-bits integers (False) or reduce-range 7-bits integers (True).
As a baseline, it is always recommended testing with full range (reduce_range = False) and then, if
accuracy drop is significant, to try with reduced range (reduce_range = True).
Intel&#x2019;s CPUs using AVX512 (non VNNI) can suffer from saturation issue when invoking
the VPMADDUBSW instruction. To counter this, one should use 7-bits rather than 8-bits integers.`,name:"reduce_range"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to quantize. If <code>None</code>, all nodes being operators from <code>operators_to_quantize</code> will be quantized.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to exclude from quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Type of nodes to perform quantization on. By default, all the quantizable operators will be quantized.`,name:"operators_to_quantize"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L488"}}),oe=new z({props:{name:"avx512_vnni",anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni",parameters:[{name:"is_static",val:": bool"},{name:"use_symmetric_activations",val:": bool = False"},{name:"use_symmetric_weights",val:": bool = True"},{name:"per_channel",val:": bool = True"},{name:"nodes_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"nodes_to_exclude",val:": typing.Optional[typing.List[str]] = None"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.is_static",description:`<strong>is_static</strong> (<code>bool</code>) &#x2014;
Boolean flag to indicate whether we target static or dynamic quantization.`,name:"is_static"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.use_symmetric_activations",description:`<strong>use_symmetric_activations</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use symmetric quantization for activations.`,name:"use_symmetric_activations"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.use_symmetric_weights",description:`<strong>use_symmetric_weights</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use symmetric quantization for weights.`,name:"use_symmetric_weights"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can
increase overall accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to quantize. If <code>None</code>, all nodes being operators from <code>operators_to_quantize</code> will be quantized.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to exclude from quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.avx512_vnni.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Type of nodes to perform quantization on. By default, all the quantizable operators will be quantized.`,name:"operators_to_quantize"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L544"}}),ie=new z({props:{name:"tensorrt",anchor:"optimum.onnxruntime.AutoQuantizationConfig.tensorrt",parameters:[{name:"per_channel",val:": bool = True"},{name:"nodes_to_quantize",val:": typing.Optional[typing.List[str]] = None"},{name:"nodes_to_exclude",val:": typing.Optional[typing.List[str]] = None"},{name:"operators_to_quantize",val:": typing.Optional[typing.List[str]] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.AutoQuantizationConfig.tensorrt.per_channel",description:`<strong>per_channel</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether we should quantize per-channel (also known as &#x201C;per-row&#x201D;). Enabling this can
increase overall accuracy while making the quantized model heavier.`,name:"per_channel"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.tensorrt.nodes_to_quantize",description:`<strong>nodes_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to quantize. If <code>None</code>, all nodes being operators from <code>operators_to_quantize</code> will be quantized.`,name:"nodes_to_quantize"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.tensorrt.nodes_to_exclude",description:`<strong>nodes_to_exclude</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Specific nodes to exclude from quantization.`,name:"nodes_to_exclude"},{anchor:"optimum.onnxruntime.AutoQuantizationConfig.tensorrt.operators_to_quantize",description:`<strong>operators_to_quantize</strong> (<code>Optional[List[str]]</code>, defaults to <code>None</code>) &#x2014;
Type of nodes to perform quantization on. By default, all the quantizable operators will be quantized.`,name:"operators_to_quantize"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L601"}}),ae=new Qe({props:{title:"CalibrationConfig",local:"optimum.onnxruntime.CalibrationConfig",headingTag:"h3"}}),re=new z({props:{name:"class optimum.onnxruntime.CalibrationConfig",anchor:"optimum.onnxruntime.CalibrationConfig",parameters:[{name:"dataset_name",val:": str"},{name:"dataset_config_name",val:": str"},{name:"dataset_split",val:": str"},{name:"dataset_num_samples",val:": int"},{name:"method",val:": CalibrationMethod"},{name:"num_bins",val:": typing.Optional[int] = None"},{name:"num_quantized_bins",val:": typing.Optional[int] = None"},{name:"percentile",val:": typing.Optional[float] = None"},{name:"moving_average",val:": typing.Optional[bool] = None"},{name:"averaging_constant",val:": typing.Optional[float] = None"}],parametersDescription:[{anchor:"optimum.onnxruntime.CalibrationConfig.dataset_name",description:`<strong>dataset_name</strong> (<code>str</code>) &#x2014;
The name of the calibration dataset.`,name:"dataset_name"},{anchor:"optimum.onnxruntime.CalibrationConfig.dataset_config_name",description:`<strong>dataset_config_name</strong> (<code>str</code>) &#x2014;
The name of the calibration dataset configuration.`,name:"dataset_config_name"},{anchor:"optimum.onnxruntime.CalibrationConfig.dataset_split",description:`<strong>dataset_split</strong> (<code>str</code>) &#x2014;
Which split of the dataset is used to perform the calibration step.`,name:"dataset_split"},{anchor:"optimum.onnxruntime.CalibrationConfig.dataset_num_samples",description:`<strong>dataset_num_samples</strong> (<code>int</code>) &#x2014;
The number of samples composing the calibration dataset.`,name:"dataset_num_samples"},{anchor:"optimum.onnxruntime.CalibrationConfig.method",description:`<strong>method</strong> (<code>CalibrationMethod</code>) &#x2014;
The method chosen to calculate the activations quantization parameters using the calibration dataset.`,name:"method"},{anchor:"optimum.onnxruntime.CalibrationConfig.num_bins",description:`<strong>num_bins</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
The number of bins to use when creating the histogram when performing the calibration step using the
Percentile or Entropy method.`,name:"num_bins"},{anchor:"optimum.onnxruntime.CalibrationConfig.num_quantized_bins",description:`<strong>num_quantized_bins</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
The number of quantized bins to use when performing the calibration step using the Entropy method.`,name:"num_quantized_bins"},{anchor:"optimum.onnxruntime.CalibrationConfig.percentile",description:`<strong>percentile</strong> (<code>Optional[float]</code>, defaults to <code>None</code>) &#x2014;
The percentile to use when computing the activations quantization ranges when performing the calibration
step using the Percentile method.`,name:"percentile"},{anchor:"optimum.onnxruntime.CalibrationConfig.moving_average",description:`<strong>moving_average</strong> (<code>Optional[bool]</code>, defaults to <code>None</code>) &#x2014;
Whether to compute the moving average of the minimum and maximum values when performing the calibration step
using the MinMax method.`,name:"moving_average"},{anchor:"optimum.onnxruntime.CalibrationConfig.averaging_constant",description:`<strong>averaging_constant</strong> (<code>Optional[float]</code>, defaults to <code>None</code>) &#x2014;
The constant smoothing factor to use when computing the moving average of the minimum and maximum values.
Effective only when the MinMax calibration method is selected and <code>moving_average</code> is set to True.`,name:"averaging_constant"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L48"}}),se=new Qe({props:{title:"ORTConfig",local:"optimum.onnxruntime.ORTConfig",headingTag:"h2"}}),me=new z({props:{name:"class optimum.onnxruntime.ORTConfig",anchor:"optimum.onnxruntime.ORTConfig",parameters:[{name:"opset",val:": typing.Optional[int] = None"},{name:"use_external_data_format",val:": bool = False"},{name:"one_external_file",val:": bool = True"},{name:"optimization",val:": typing.Optional[optimum.onnxruntime.configuration.OptimizationConfig] = None"},{name:"quantization",val:": typing.Optional[optimum.onnxruntime.configuration.QuantizationConfig] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"optimum.onnxruntime.ORTConfig.opset",description:`<strong>opset</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
ONNX opset version to export the model with.`,name:"opset"},{anchor:"optimum.onnxruntime.ORTConfig.use_external_data_format",description:`<strong>use_external_data_format</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Allow exporting model &gt;= than 2Gb.`,name:"use_external_data_format"},{anchor:"optimum.onnxruntime.ORTConfig.one_external_file",description:`<strong>one_external_file</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
When <code>use_external_data_format=True</code>, whether to save all tensors to one external file.
If false, save each tensor to a file named with the tensor name.
(Can not be set to <code>False</code> for the quantization)`,name:"one_external_file"},{anchor:"optimum.onnxruntime.ORTConfig.optimization",description:`<strong>optimization</strong> (<code>Optional[OptimizationConfig]</code>, defaults to <code>None</code>) &#x2014;
Specify a configuration to optimize ONNX Runtime model`,name:"optimization"},{anchor:"optimum.onnxruntime.ORTConfig.quantization",description:`<strong>quantization</strong> (<code>Optional[QuantizationConfig]</code>, defaults to <code>None</code>) &#x2014;
Specify a configuration to quantize ONNX Runtime model`,name:"quantization"}],source:"https://github.com/huggingface/optimum/blob/main/optimum/onnxruntime/configuration.py#L945"}}),{c(){q=a("meta"),Ae=o(),Ne=a("p"),Le=o(),u(W.$$.fragment),Fe=o(),V=a("p"),V.textContent=It,De=o(),R=a("ol"),R.innerHTML=Mt,Pe=o(),u(E.$$.fragment),Ie=o(),w=a("div"),u(H.$$.fragment),st=o(),ue=a("p"),ue.textContent=Wt,mt=o(),de=a("ol"),de.innerHTML=Vt,Me=o(),_=a("div"),u(X.$$.fragment),ut=o(),le=a("p"),le.innerHTML=Rt,dt=o(),N=a("div"),u(U.$$.fragment),lt=o(),ce=a("p"),ce.innerHTML=Et,ct=o(),k=a("div"),u(S.$$.fragment),pt=o(),pe=a("p"),pe.innerHTML=Ht,gt=o(),A=a("div"),u(G.$$.fragment),ft=o(),ge=a("p"),ge.innerHTML=Xt,_t=o(),L=a("div"),u(B.$$.fragment),ht=o(),fe=a("p"),fe.innerHTML=Ut,xt=o(),F=a("div"),u(j.$$.fragment),bt=o(),_e=a("p"),_e.innerHTML=St,We=o(),u(K.$$.fragment),Ve=o(),$=a("div"),u(J.$$.fragment),zt=o(),he=a("p"),he.textContent=Gt,Re=o(),u(Y.$$.fragment),Ee=o(),b=a("div"),u(Z.$$.fragment),vt=o(),D=a("div"),u(ee.$$.fragment),yt=o(),xe=a("p"),xe.innerHTML=Bt,Ct=o(),P=a("div"),u(te.$$.fragment),wt=o(),be=a("p"),be.innerHTML=jt,Ot=o(),I=a("div"),u(ne.$$.fragment),qt=o(),ze=a("p"),ze.innerHTML=Kt,$t=o(),v=a("div"),u(oe.$$.fragment),Tt=o(),ve=a("p"),ve.innerHTML=Jt,Qt=o(),ye=a("p"),ye.textContent=Yt,Nt=o(),Ce=a("p"),Ce.textContent=Zt,kt=o(),we=a("p"),we.textContent=en,At=o(),M=a("div"),u(ie.$$.fragment),Lt=o(),Oe=a("p"),Oe.innerHTML=tn,He=o(),u(ae.$$.fragment),Xe=o(),T=a("div"),u(re.$$.fragment),Ft=o(),qe=a("p"),qe.textContent=nn,Ue=o(),u(se.$$.fragment),Se=o(),Q=a("div"),u(me.$$.fragment),Dt=o(),$e=a("p"),$e.textContent=on,Ge=o(),ke=a("p"),this.h()},l(e){const s=dn("svelte-u9bgzb",document.head);q=r(s,"META",{name:!0,content:!0}),s.forEach(n),Ae=i(e),Ne=r(e,"P",{}),h(Ne).forEach(n),Le=i(e),d(W.$$.fragment,e),Fe=i(e),V=r(e,"P",{"data-svelte-h":!0}),f(V)!=="svelte-1shhltv"&&(V.textContent=It),De=i(e),R=r(e,"OL",{"data-svelte-h":!0}),f(R)!=="svelte-4c986i"&&(R.innerHTML=Mt),Pe=i(e),d(E.$$.fragment,e),Ie=i(e),w=r(e,"DIV",{class:!0});var Te=h(w);d(H.$$.fragment,Te),st=i(Te),ue=r(Te,"P",{"data-svelte-h":!0}),f(ue)!=="svelte-kud8lz"&&(ue.textContent=Wt),mt=i(Te),de=r(Te,"OL",{"data-svelte-h":!0}),f(de)!=="svelte-1347rzr"&&(de.innerHTML=Vt),Te.forEach(n),Me=i(e),_=r(e,"DIV",{class:!0});var y=h(_);d(X.$$.fragment,y),ut=i(y),le=r(y,"P",{"data-svelte-h":!0}),f(le)!=="svelte-z99vag"&&(le.innerHTML=Rt),dt=i(y),N=r(y,"DIV",{class:!0});var je=h(N);d(U.$$.fragment,je),lt=i(je),ce=r(je,"P",{"data-svelte-h":!0}),f(ce)!=="svelte-o9g052"&&(ce.innerHTML=Et),je.forEach(n),ct=i(y),k=r(y,"DIV",{class:!0});var Ke=h(k);d(S.$$.fragment,Ke),pt=i(Ke),pe=r(Ke,"P",{"data-svelte-h":!0}),f(pe)!=="svelte-gkopyf"&&(pe.innerHTML=Ht),Ke.forEach(n),gt=i(y),A=r(y,"DIV",{class:!0});var Je=h(A);d(G.$$.fragment,Je),ft=i(Je),ge=r(Je,"P",{"data-svelte-h":!0}),f(ge)!=="svelte-1b21ddg"&&(ge.innerHTML=Xt),Je.forEach(n),_t=i(y),L=r(y,"DIV",{class:!0});var Ye=h(L);d(B.$$.fragment,Ye),ht=i(Ye),fe=r(Ye,"P",{"data-svelte-h":!0}),f(fe)!=="svelte-mclel1"&&(fe.innerHTML=Ut),Ye.forEach(n),xt=i(y),F=r(y,"DIV",{class:!0});var Ze=h(F);d(j.$$.fragment,Ze),bt=i(Ze),_e=r(Ze,"P",{"data-svelte-h":!0}),f(_e)!=="svelte-cq6eru"&&(_e.innerHTML=St),Ze.forEach(n),y.forEach(n),We=i(e),d(K.$$.fragment,e),Ve=i(e),$=r(e,"DIV",{class:!0});var et=h($);d(J.$$.fragment,et),zt=i(et),he=r(et,"P",{"data-svelte-h":!0}),f(he)!=="svelte-9xjx81"&&(he.textContent=Gt),et.forEach(n),Re=i(e),d(Y.$$.fragment,e),Ee=i(e),b=r(e,"DIV",{class:!0});var C=h(b);d(Z.$$.fragment,C),vt=i(C),D=r(C,"DIV",{class:!0});var tt=h(D);d(ee.$$.fragment,tt),yt=i(tt),xe=r(tt,"P",{"data-svelte-h":!0}),f(xe)!=="svelte-18mnssu"&&(xe.innerHTML=Bt),tt.forEach(n),Ct=i(C),P=r(C,"DIV",{class:!0});var nt=h(P);d(te.$$.fragment,nt),wt=i(nt),be=r(nt,"P",{"data-svelte-h":!0}),f(be)!=="svelte-1o9gfzv"&&(be.innerHTML=jt),nt.forEach(n),Ot=i(C),I=r(C,"DIV",{class:!0});var ot=h(I);d(ne.$$.fragment,ot),qt=i(ot),ze=r(ot,"P",{"data-svelte-h":!0}),f(ze)!=="svelte-muqczp"&&(ze.innerHTML=Kt),ot.forEach(n),$t=i(C),v=r(C,"DIV",{class:!0});var O=h(v);d(oe.$$.fragment,O),Tt=i(O),ve=r(O,"P",{"data-svelte-h":!0}),f(ve)!=="svelte-1tpe9nz"&&(ve.innerHTML=Jt),Qt=i(O),ye=r(O,"P",{"data-svelte-h":!0}),f(ye)!=="svelte-pb6daa"&&(ye.textContent=Yt),Nt=i(O),Ce=r(O,"P",{"data-svelte-h":!0}),f(Ce)!=="svelte-167rhrj"&&(Ce.textContent=Zt),kt=i(O),we=r(O,"P",{"data-svelte-h":!0}),f(we)!=="svelte-vqsk0u"&&(we.textContent=en),O.forEach(n),At=i(C),M=r(C,"DIV",{class:!0});var it=h(M);d(ie.$$.fragment,it),Lt=i(it),Oe=r(it,"P",{"data-svelte-h":!0}),f(Oe)!=="svelte-1r78z9p"&&(Oe.innerHTML=tn),it.forEach(n),C.forEach(n),He=i(e),d(ae.$$.fragment,e),Xe=i(e),T=r(e,"DIV",{class:!0});var at=h(T);d(re.$$.fragment,at),Ft=i(at),qe=r(at,"P",{"data-svelte-h":!0}),f(qe)!=="svelte-12bp9yw"&&(qe.textContent=nn),at.forEach(n),Ue=i(e),d(se.$$.fragment,e),Se=i(e),Q=r(e,"DIV",{class:!0});var rt=h(Q);d(me.$$.fragment,rt),Dt=i(rt),$e=r(rt,"P",{"data-svelte-h":!0}),f($e)!=="svelte-10zam97"&&($e.textContent=on),rt.forEach(n),Ge=i(e),ke=r(e,"P",{}),h(ke).forEach(n),this.h()},h(){x(q,"name","hf:doc:metadata"),x(q,"content",cn),x(w,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(k,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(_,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(P,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),x(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){t(document.head,q),m(e,Ae,s),m(e,Ne,s),m(e,Le,s),l(W,e,s),m(e,Fe,s),m(e,V,s),m(e,De,s),m(e,R,s),m(e,Pe,s),l(E,e,s),m(e,Ie,s),m(e,w,s),l(H,w,null),t(w,st),t(w,ue),t(w,mt),t(w,de),m(e,Me,s),m(e,_,s),l(X,_,null),t(_,ut),t(_,le),t(_,dt),t(_,N),l(U,N,null),t(N,lt),t(N,ce),t(_,ct),t(_,k),l(S,k,null),t(k,pt),t(k,pe),t(_,gt),t(_,A),l(G,A,null),t(A,ft),t(A,ge),t(_,_t),t(_,L),l(B,L,null),t(L,ht),t(L,fe),t(_,xt),t(_,F),l(j,F,null),t(F,bt),t(F,_e),m(e,We,s),l(K,e,s),m(e,Ve,s),m(e,$,s),l(J,$,null),t($,zt),t($,he),m(e,Re,s),l(Y,e,s),m(e,Ee,s),m(e,b,s),l(Z,b,null),t(b,vt),t(b,D),l(ee,D,null),t(D,yt),t(D,xe),t(b,Ct),t(b,P),l(te,P,null),t(P,wt),t(P,be),t(b,Ot),t(b,I),l(ne,I,null),t(I,qt),t(I,ze),t(b,$t),t(b,v),l(oe,v,null),t(v,Tt),t(v,ve),t(v,Qt),t(v,ye),t(v,Nt),t(v,Ce),t(v,kt),t(v,we),t(b,At),t(b,M),l(ie,M,null),t(M,Lt),t(M,Oe),m(e,He,s),l(ae,e,s),m(e,Xe,s),m(e,T,s),l(re,T,null),t(T,Ft),t(T,qe),m(e,Ue,s),l(se,e,s),m(e,Se,s),m(e,Q,s),l(me,Q,null),t(Q,Dt),t(Q,$e),m(e,Ge,s),m(e,ke,s),Be=!0},p:rn,i(e){Be||(c(W.$$.fragment,e),c(E.$$.fragment,e),c(H.$$.fragment,e),c(X.$$.fragment,e),c(U.$$.fragment,e),c(S.$$.fragment,e),c(G.$$.fragment,e),c(B.$$.fragment,e),c(j.$$.fragment,e),c(K.$$.fragment,e),c(J.$$.fragment,e),c(Y.$$.fragment,e),c(Z.$$.fragment,e),c(ee.$$.fragment,e),c(te.$$.fragment,e),c(ne.$$.fragment,e),c(oe.$$.fragment,e),c(ie.$$.fragment,e),c(ae.$$.fragment,e),c(re.$$.fragment,e),c(se.$$.fragment,e),c(me.$$.fragment,e),Be=!0)},o(e){p(W.$$.fragment,e),p(E.$$.fragment,e),p(H.$$.fragment,e),p(X.$$.fragment,e),p(U.$$.fragment,e),p(S.$$.fragment,e),p(G.$$.fragment,e),p(B.$$.fragment,e),p(j.$$.fragment,e),p(K.$$.fragment,e),p(J.$$.fragment,e),p(Y.$$.fragment,e),p(Z.$$.fragment,e),p(ee.$$.fragment,e),p(te.$$.fragment,e),p(ne.$$.fragment,e),p(oe.$$.fragment,e),p(ie.$$.fragment,e),p(ae.$$.fragment,e),p(re.$$.fragment,e),p(se.$$.fragment,e),p(me.$$.fragment,e),Be=!1},d(e){e&&(n(Ae),n(Ne),n(Le),n(Fe),n(V),n(De),n(R),n(Pe),n(Ie),n(w),n(Me),n(_),n(We),n(Ve),n($),n(Re),n(Ee),n(b),n(He),n(Xe),n(T),n(Ue),n(Se),n(Q),n(Ge),n(ke)),n(q),g(W,e),g(E,e),g(H),g(X),g(U),g(S),g(G),g(B),g(j),g(K,e),g(J),g(Y,e),g(Z),g(ee),g(te),g(ne),g(oe),g(ie),g(ae,e),g(re),g(se,e),g(me)}}}const cn='{"title":"Configuration","local":"configuration","sections":[{"title":"OptimizationConfig","local":"optimum.onnxruntime.OptimizationConfig","sections":[],"depth":2},{"title":"QuantizationConfig","local":"optimum.onnxruntime.QuantizationConfig","sections":[],"depth":2},{"title":"AutoQuantizationConfig","local":"optimum.onnxruntime.AutoQuantizationConfig","sections":[{"title":"CalibrationConfig","local":"optimum.onnxruntime.CalibrationConfig","sections":[],"depth":3}],"depth":2},{"title":"ORTConfig","local":"optimum.onnxruntime.ORTConfig","sections":[],"depth":2}],"depth":1}';function pn(Pt){return sn(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class xn extends mn{constructor(q){super(),un(this,q,pn,ln,an,{})}}export{xn as component};
